---
# if you have any prepararion task
- name: "Prepare"
  hosts: "local"
  gather_facts: true
  tasks:

    - name: "Include labocbz.prepare_host"
      tags:
        - "labocbz.prepare_host"
      vars:
        prepare_host__users_to_add: "{{ inv__prepare_host__users_to_add }}"
      ansible.builtin.include_role:
        name: "labocbz.prepare_host"

    - name: "Gather facts from all hosts"
      delegate_to: "{{ host }}"
      delegate_facts: true
      become: true
      loop: "{{ groups['local'] }}"
      loop_control:
        loop_var: "host"
      ansible.builtin.setup:

    - name: "Edit /etc/hosts file to add all hosts"
      loop: "{{ groups['local'] }}"
      loop_control:
        loop_var: "host"
      become: true
      ansible.builtin.shell: "echo \"{{ hostvars[host]['ansible_default_ipv4']['address'] }}  {{ host }} # from Molecule\" >> /etc/hosts"

    - name: "Include cryptographic content var file"
      ansible.builtin.include_vars: "../../tests/certs/main.yml"

    - name: "Import certificates if needed"
      when: "import_certificate__bundles is defined"
      block:
        - name: "Import cryptographic content if needed"
          loop: "{{ import_certificate__bundles }}"
          loop_control:
            loop_var: "certficate_bundle"
          ansible.builtin.copy:
            src: "../../tests/certs/{{ certficate_bundle.name }}"
            dest: "/tmp/{{ certficate_bundle.name }}"
            owner: "root"
            group: "root"
            mode: "0700"

        - name: "Include labocbz.import_certificate"
          tags:
            - "labocbz.import_certificate"
          loop: "{{ import_certificate__bundles }}"
          loop_control:
            loop_var: "certificate_bundle"
          vars:
            import_certificate__bundle_name: "{{ certificate_bundle.name }}"
            import_certificate__bundle_type: "{{ certificate_bundle.type }}"
            import_certificate__bundle_src: "{{ certificate_bundle.src }}"
            import_certificate__bundle_dest: "{{ certificate_bundle.dest }}"
            import_certificate__bundle_src_user: "{{ certificate_bundle.src_user }}"
            import_certificate__bundle_src_password: "{{ certificate_bundle.src_password }}"
            import_certificate__bundle_dest_user: "{{ certificate_bundle.dest_user }}"
            import_certificate__bundle_dest_group: "{{ certificate_bundle.dest_group }}"
            import_certificate__bundle_dest_mode: "{{ certificate_bundle.dest_mode }}"
          ansible.builtin.include_role:
            name: "labocbz.import_certificate"

    - name: "Include labocbz.install_java"
      tags:
        - "labocbz.install_java"
      vars:
        install_java__version: "{{ inv__install_java__version }}"
        install_java__cpu_architecture: "{{ inv__install_java__cpu_architecture }}"
        install_java__version_is_default: "{{ inv__install_java__version_is_default }}"
      ansible.builtin.include_role:
        name: "labocbz.install_java"

    - name: "Include labocbz.install_docker"
      tags:
        - "labocbz.install_docker"
      vars:
        install_docker__compose_version: "{{ inv__install_docker__compose_version  }}"
        install_docker__enable_swap: "{{ inv__install_docker__enable_swap  }}"
        install_docker__system_clean: "{{ inv__install_docker__system_clean  }}"
      ansible.builtin.include_role:
        name: "labocbz.install_docker"
